//
//  Bicycle.swift
//  SwiftArchiving
//
//  Created by Marcel Zickler on 13.12.16.
//  Subclass of Vehicle with additional instance variables
//

import Foundation

class Bicycle: Vehicle{
    
    let type: String
    let frameSize: Int
    //for showing it on UI
    override var description: String{
        get{
            return "Bicyclie of type \(type): \(model) from \(manufacturer) with framesize \(frameSize) and \(numberOfWheels) Wheels"
        }
    }
    
    static let KEY_TYPE = "type"
    static let KEY_FRAME_SIZE = "frameSize"
    
    init(manufacturer: String, model:String, type: String, frameSize: Int) {
        self.type = type
        self.frameSize = frameSize
        super.init(manufacturer: manufacturer, model: model, numberOfWheels: 2)
    }
    
    //have to get all items from the dict and initialize this class with them
    required convenience init(withDict dict: ArchiveDict) {
        if let t = dict.getString(forKey: Bicycle.KEY_TYPE),
            let fs = dict.getInt(forKey: Bicycle.KEY_FRAME_SIZE),
            let man = dict.getString(forKey: Car.KEY_MANUFACTURER),
            let mod = dict.getString(forKey: Car.KEY_MODEL){
            self.init(manufacturer: man, model: mod, type: t, frameSize: fs)
        }else{
            fatalError("cannot init with dict, because some key is missing")
        }

    }
    
    //encode all variables from parent and then its own
    override func encode(withDict dict: inout ArchiveDict) {
        super.encode(withDict: &dict)
        dict.putString(type, forKey: Bicycle.KEY_TYPE)
        dict.putInt(frameSize, forKey: Bicycle.KEY_FRAME_SIZE)
    }

}
