//
//  SwiftKeyedArchiver.swift
//  SwiftArchiving
//
//  Created by Marcel Zickler on 13.12.16.
//  Provides function to archive and restore SwiftCoding objects
//

import Foundation

public class SwiftKeyedArchiver{
    
    class func archive(rootObject: SwiftCoding, toFile file: String) throws -> Bool{
        //create a dict and pass it as a reference to the object to be serialized
        var dict = ArchiveDict()
        rootObject.encode(withDict: &dict)
        //after all instance variables were added to the dict, they can be written to a plist
        return dict.write(toFile: file) //returns true, if successfull
    }
    
    //propably a very bad solution. If you know which object to restore from which file you can just pass the dictionary to it. Otherwise you have to find out which class it could be.
    class func restore(fromFile file: String) -> SwiftCoding?{
        if let dict = ArchiveDict(contentsOfFile: file){ //converts plist to dict
            if(dict.getInt(forKey: Car.KEY_HP) != nil){
                //is a car
                return Car(withDict: dict)
            }else if(dict.getInt(forKey: Bicycle.KEY_FRAME_SIZE) != nil){
                //is a bicycle
                return Bicycle(withDict: dict)
            }else if(dict.getInt(forKey: Vehicle.KEY_NUMBER_OF_WHEELS) != nil){
                //is a vehicle
                return Vehicle(withDict: dict)
            }
        }
        return nil
    }
    
}
